#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Menu "Data"
	"Extract Wave Subranges", mExtractWaveSubrange()
end

Function mExtractWaveSubrange()

	String wavelistfilter = "*"
	Variable startPoint, endPoint
	Prompt wavelistfilter, "WaveList filter string:"
	Prompt startPoint, "Subrange starting point:"
	Prompt endPoint, "Subrange ending point:"
	DoPrompt "Extract Wave Subranges", wavelistfilter, startPoint, endPoint
	if (V_flag == 0)
		ExtractWaveSubrange(WaveList(wavelistfilter, ";", ""), startPoint, endPoint)
	endif
end

Function ExtractWaveSubrange(wlist, startPoint, endPoint)
	String wlist
	Variable startPoint, endPoint
	
	Variable i
	Variable nitems = ItemsInList(wlist)
	for (i = 0; i < nitems; i += 1)
		WAVE/Z onewave = $StringFromList(i, wlist)
		if (!WaveExists(onewave))
			DoAlert 0, "The wave "+StringFromList(i, wlist)+" does not exist."
			continue
		endif
		String newname = NameOfWave(onewave)+"_sub"
		Duplicate/O/R=[startPoint, endPoint] onewave, $newname
	endfor
end
